################################################################################
# Copyright 2006-2007 Novell, Inc.
# Author: Charles Coffing <ccoffing@novell.com>
#
# This software may be freely redistributed under the terms of the GNU
# general public license.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA 
#
# Base hypervisor class.
#
################################################################################

################################################################################
# GLOBAL DECLARAIONS
################################################################################
connection = None
max_nics   = 8



################################################################################
# Class: Hypervisor
#
# Generic class for all hypervisors.
################################################################################
class Hypervisor:


    #---------------------------------------------------------------------------
    # Method: delete
    #
    # This method is stubb so that individual hypervisor logic can define their own.
    #---------------------------------------------------------------------------
    def delete(self, domid):
        #TODO: any code that is stubb, should probably produce an exception
        pass


    #---------------------------------------------------------------------------
    # Method: delete
    #
    # This method is stubb so that individual hypervisor logic can define their own.
    #---------------------------------------------------------------------------
    def destroy(self, domid):
        """Destroys a running instance; does not erase from xend"""
        #TODO: any code that is stubb, should probably produce an exception
        pass


    #---------------------------------------------------------------------------
    # Method: domain
    # This method is stubb so that individual hypervisor logic can define their own.
    #---------------------------------------------------------------------------
    def domain(self, domid):
        #TODO: any code that is stubb, should probably produce an exception
        pass


    #---------------------------------------------------------------------------
    # Method: domain_running
    #---------------------------------------------------------------------------
    def domain_running(self, domid):
        #TODO: any code that is stubb, should probably produce an exception
        pass


    #---------------------------------------------------------------------------
    # Method: getconn
    #---------------------------------------------------------------------------
    def getconn(self):
        return None


    #---------------------------------------------------------------------------
    # Method: reset_connection
    #---------------------------------------------------------------------------
    def reset_connection(self, uri=None):
        return None


    #---------------------------------------------------------------------------
    # Method: get_dom0_min_memory
    #
    # This method is stubb so that individual hypervisor logic can define their own.
    #---------------------------------------------------------------------------
    def get_dom0_min_memory(self):
        #TODO: any code that is stubb, should probably produce an exception
        pass


    #---------------------------------------------------------------------------
    # Method: getURI
    #---------------------------------------------------------------------------
    def getURI(self):
        return self.uri


    #---------------------------------------------------------------------------
    # Method: lookup
    #
    # This method is stubb so that individual hypervisor logic can define their own.
    #---------------------------------------------------------------------------
    def lookup(self, domid):
        #TODO: any code that is stubb, should probably produce an exception
        pass

    #---------------------------------------------------------------------------
    # Method: wait_domain
    #
    # This method is stubb so that individual hypervisor logic can define their own.
    #---------------------------------------------------------------------------
    def wait_domain(self, domid):
        #TODO: any code that is stubb, should probably produce an exception
        pass

