# Translatable strings
#
# Copyright 2006-2007 Novell, Inc.
# Author: Charles Coffing <ccoffing@novell.com>
#
# This software may be freely redistributed under the terms of the GNU
# general public license.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA 

import gettext
import locale

gettext_app = 'xen-vm-install'
#locale.setlocale(locale.LC_ALL, '')
gettext.install(gettext_app)
gettext.bindtextdomain(gettext_app)

#  Error messages & titles
install_error = _("Installation Error")
error = _("Error")
warning = _("Warning")
aborted = _("Aborted")
invalid_url = _("Invalid URL")
suse_kernel_not_found = _("The 'kernel-xen' and 'install-initrd' packages were not found.")
#TRANSLATORS Do not translate %(tag)s
malformed_xml = _("Failed to find the '%(tag)s' tag in the XML file.")
#TRANSLATORS Do not translate %(file)s
parse_failed = _("Failed to parse the XML file '%(file)s'.")
disk_block_or_file = _("The virtual disk may only be stored on a block device or in a file.")
no_media = _("No media is present in the drive.")
must_be_root = _("Must be the 'root' user to run vm-install")
libvirt_connection = _("Failed to open a connection to libvirt. Please verify the libvirt daemon is running.")

#  Error prompts for the CLI
correct_retry = _("Please correct the error and try again.")
prompt_number = _("Please type a number.")
#TRANSLATORS Do not translate %(val)s
min_val = _("The minimum acceptable value is %(val)s.")
#TRANSLATORS Do not translate %(val)s
max_val = _("The maximum acceptable value is %(val)s.")

#  Errors regarding VM names
name_alpha = _("The VM's name must contain only alphanumeric and _ - . : + characters.")
name_len = _("The VM's name must contain from 1 to 255 characters.")
name_start = _("The VM's name cannot start with a digit.")

#  Console messages/errors
vnc_no_display = _("Failed to display the VM's console because DISPLAY is not set.  Please connect a VNC viewer to %s:%d.")
display_failed = _("Failed to display the VM's console.  Please connect a viewer manually.")
#connect_viewer = _("Please connect a VNC viewer to %s:%d.")

#  Titles of "xen" exceptions
exc_xen_err   = _("An error occurred in Xen.")
exc_xen_none  = _("The hypervisor is not running.")
exc_xen_ver   = _("An incompatible version of the hypervisor is running.")
exc_xen_xend  = _("Unable to connect to the Xen daemon.")
exc_xen_root  = _("Must be the 'root' user to manage Xen.")

#  Titles of "vm" exceptions
exc_vm_start = _("Failed to start the VM.")
exc_vm_crash = _("The VM has crashed.")
exc_vm_exists =  _("A VM by that name is already running.")
exc_vm_conf_exists = _("A VM configuration already exists with that name.")
exc_vm_bootloader = _("A valid boot sector was not found.  The installation may have failed.")
exc_vm_kernel = _("No kernel was found.  The installation may have failed.")
exc_vm_running = _("You must shutdown the VM before upgrading.")

#  Titles of "installation source" exceptions
exc_src_unsup = _("The installation source is using an unsupported protocol.")
exc_src_ioerr = _("An error occurred while reading from the installation source.")
exc_src_no    = _("The installation source was not found.")
exc_src_bad   = _("The installation source is unusable.")
exc_src_undef = _("No installation source was defined.")
exc_src_cdrom = _("A CD-ROM or DVD must be specified from which to boot.")
exc_src_config = _("An error occurred while reading the configuration file.")

#  Titles of "resource: architecture" exceptions
exc_arch_incompat = _("The operating system is incompatible with the processor architecture of this machine.")
exc_arch_novt = _("The processor(s) in this machine do not support full virtualization.")
exc_arch_novt_bios = _("The processor(s) in this machine support full virtualization, but it is disabled in the BIOS.")

#  Titles of "resource: memory" exceptions
exc_mem_no = _("Not enough memory.")

#  Titles of "resource: host devices" exceptions
exc_hd_failure = _("Failed to make host device available for VM.")
exc_hd_pciback = _("Pciback kernel module is not loaded.")
exc_hd_unbind = _("Unbinding device from host failed.")
exc_hd_new_slot = _("Unable to make host device available.")
exc_hd_bind = _("Binding host device to pciback failed.")
exc_hd_in_use = _("Host device is in use by another VM.")

#  Titles of "resource: disk" exceptions
exc_disk_no   = _("The disk does not exist.")
exc_disk_ro   = _("The disk is read-only.")
exc_disk_perm = _("Permission was denied while attempting to access the disk.")
exc_disk_conflict = _("Two of the virtual disks have conflicting virtual names or physical devices.")
exc_disk_no_space = _("Not enough space on device for disk image.")
exc_disk_create_failed = _("Create disk image failed.")
exc_disk_overcommit = _("You are overcommitting the amount of disk space available on this device.  Continue anyways?")

#  Titles of "job" exceptions
exc_job_canceled = _("The job was canceled.")
exc_job_no       = _("The job was not found.")
exc_job_state    = _("The job is in the wrong state to perform that action.")

#  Titles of "parameter" exceptions
exc_param_noninter = exc_param_invalid = _("A parameter is invalid or missing.")
exc_param_nopara = _("The operating system does not support paravirtualization.")
exc_param_noauto = _("The operating system does not support automated installations.")
exc_param_nofull = _("The operating system does not support full virtualization.")
exc_param_noupgrade = _("The operating system cannot be upgraded from this tool.")

#  Names of operating systems
os_netware = _("NetWare")
os_redhat = _("RedHat")
os_suse = _("SUSE")
os_ubuntu = _("Ubuntu")
os_windows = _("Windows")
os_solaris = _("Solaris")
os_other = _("Other")
os_rear = _("ReaR")


nw65_older = _("Novell NetWare 6.5 SP6 and older")
oes2l = _("Novell Open Enterprise Server 2 (Linux)")
oes11 = _("Novell Open Enterprise Server 11")
oes2nw = _("Novell Open Enterprise Server 2 (NetWare)")
opensuse = _("openSUSE")
opensuse11 = _("openSUSE 11")
opensuse12 = _("openSUSE 12")
opensuse13 = _("openSUSE 13")
opensuse42 = _("openSUSE 42")
opensuse15 = _("openSUSE 15")
opensuse_tumbleweed = _("openSUSE Tumbleweed")
other_os = _("Other operating system")
redhat_other = _("RedHat (other)")
rhel3 = _("RedHat Enterprise Linux 3")
rhel4 = _("RedHat Enterprise Linux 4")
rhel5 = _("RedHat Enterprise Linux 5")
rhel6 = _("RedHat Enterprise Linux 6")
rhel7 = _("RedHat Enterprise Linux 7")
sled10 = _("SUSE Linux Enterprise Desktop 10")
sled11 = _("SUSE Linux Enterprise Desktop 11")
sled12 = _("SUSE Linux Enterprise Desktop 12")
sled15 = _("SUSE Linux Enterprise Desktop 15")
sles10 = _("SUSE Linux Enterprise Server 10")
sles11 = _("SUSE Linux Enterprise Server 11")
sles12 = _("SUSE Linux Enterprise Server 12")
sles15 = _("SUSE Linux Enterprise Server 15")
sles8 = _("SUSE Linux Enterprise Server 8")
sles9 = _("SUSE Linux Enterprise Server 9")
solaris10 = _("Solaris 10")
solaris9 = _("Solaris 9 and older")
suse_other = _("SUSE (other)")
ubuntu_other = _("Ubuntu (other)")
ubuntu10 = _("Ubuntu 10 (Lucid Lynx, Maverick Meerkat)")
ubuntu11 = _("Ubuntu 11 (Natty Narwhal, Oneiric Ocelot)")
ubuntu12 = _("Ubuntu 12 (Precise Pangolin)")
windows_other = _("Windows (other)")
windows_other_x64 = _("Windows (other, x64)")
windows_nt = _("Windows NT")
windows_xp = _("Windows XP, 2000, 2003")
windows_xp_x64 = _("Windows XP, 2003 (x64)")
windows_vista = _("Windows Vista")
windows_vista_x64 = _("Windows Vista (x64)")
windows_7 = _("Windows 7")
windows_7_x64 = _("Windows 7 (x64)")
windows_8 = _("Windows 8")
windows_8_x64 = _("Windows 8 (x64)")
windows_10 = _("Windows 10")
windows_10_x64 = _("Windows 10 (x64)")
windows_server_2008 = _("Windows Server 2008")
windows_server_2008_x64 = _("Windows Server 2008 (x64)")
windows_server_2012 = _("Windows Server 2012 (x64)")
windows_server_2016 = _("Windows Server 2016 (x64)")
windows_server_2019 = _("Windows Server 2019 (x64)")

#  Steps of job  (some official; some unofficial...)
job_settings = _("Gathering settings...")
job_prep_install = _("Preparing to start the installation...")
job_install = _("Installing...")
please_wait = _("Please wait...")
wait_shutdown = _("Waiting for the VM to stop before continuing...")
job_post_install = _("Performing post-installation checks...")
job_runtime_conf = _("Creating the run-time configuration...")
job_conf_written = _("The configuration file has been written.")
job_runtime = _("Finishing the installation...")
job_finished = _("Finished.")

#  Generic Labels
paravirtualized = _("Paravirtualized")
fully_virtualized = _("Fully virtualized")
paravirtualization = _("Paravirtualization")
full_virtualization = _("Full virtualization")
name = _("Name")
type = _("Type")
source = _("Source")
browse = _("Browse")
upgrade = _("Upgrade")
protocol = _("Protocol")
keymap = _("Keymap")
sound = _("Sound")
none = _("None")
username = _("Username:")
password = _("Password:")
description = _("Description")
enabled = _("Enabled")
option = _("Option")
random = _("Random")
managed = _("Managed")
storage_format = _("Storage Format")

#  Titles on pages
title_intro = _("Create a Virtual Machine")
title_install = _("Install an Operating System?")
title_os_type = _("Type of Operating System")
title_summary = _("Summary")
title_method = _("Virtualization Method")
title_name = _("Name of Virtual Machine")
title_hardware = _("Hardware")
title_graphics = _("Peripheral Devices")
title_disks = _("Disks")
title_disk = _("Virtual Disk")
title_nics = _("Network Adapters")
title_nic_edit = _("Virtual Network Adapter")
title_os_install = title_fv_install = title_pv_install = _("Operating System Installation")
title_os_runtime = title_pv_runtime = _("Operating System Settings")
title_upgrade = _("Operating System Upgrade")
title_advanced = advanced_settings = _("Advanced Settings")
title_passthrough = _("Host Devices")

# Help text
intro_help1 = _("This assistant will guide you through creating a new virtual machine (VM).  You will be asked for some information about the VM you'd like to create, such as:")
intro_help2 = _("The <b>type of operating system</b> that will run in the new VM")
intro_help3 = _("Whether the VM will be <b>fully virtualized</b> or <b>paravirtualized</b>")
intro_help4 = _("The <b>location</b> of the files necessary to install an operating system on the VM, or a <b>disk</b> that already has an operating system")
intro_help5 = _("Other characteristics of the VM, such as <b>memory</b>, <b>processors</b>, and <b>network adapters</b>.")
#TRANSLATORS Do not translate %(url)s
intro_help6 = _("For the most current information on SUSE VM server technology, see ")
intro_help6_http = _("%(url)s")
install_help = _("If you are creating this VM from scratch, you will need to install an operating system.  When migrating a physical machine to a virtual machine, the disk with the existing operating system can often be reused for the VM.")
os_install_yes = _("I need to install an operating system.")
os_install_no = _("I have a disk or disk image with an installed operating system.")
os_install_upgrade = _("I need to upgrade an existing operating system.")
name_help = _("Please choose a name for the virtual machine.")
summary_help = _("Click any headline to make changes.  When the settings are correct, click <b>OK</b> to create the VM.")
method_help = _("Virtual machines can use paravirtualization or full virtualization.  Paravirtualization is faster but requires operating system support.  Full virtualization runs a broader range of operating systems but requires hardware support.  Which do you prefer?")
os_type_help = _("Please specify the type of operating system that will run within the virtual machine.  This defines many defaults, and helps decide how to start paravirtualized operating systems.")
os_settings_help = _("Some operating systems support automating the installation by specifying a URL or file(s).  Select a directory to include multiple files.")
fv_os_settings_help = os_settings_help
extra_args_help = _("Some operating systems accept additional arguments, used to customize the installation or boot process.")
exit_args_help = _("Select the behavior when the operating system exits with power off, reboot or crash.  Settings take effect after installation is complete.")
#STEVE
#install_media_help = _("Please indicate where the installation media is available for the operating system that you would like to install.")
install_media_help = _("Specify the bootable virtual disk (often labeled as Disk 1) or the network installation source URL.  Each CD, DVD, or ISO image required for installation must be added as a virtual disk.")
#STEVE
#disk_help = _("Please specify the settings for the virtual disk.")
disk_help = _("Create a virtual disk based on a device (CD or other block device), an existing image file (ISO), or a new file.  Specify a device by its device node, such as /dev/cdrom, not its mount point.")
nic_edit_help = _("Please specify the settings for the virtual network adapter.")
cli_exit_help = _("Press \'q\' or the Escape key to exit.")
advanced_help = _("Warning: Vm-install automatically manages these configuration settings depending on the operating system to be installed. It is expected that you understand clearly the consequences of enabling or disabling a particular setting.")
advanced_reset = _("Reset to Defaults")
maximum_memory_warning = _("Setting the maximum memory greater than the initial memory requires the VM operating system to have a memory balloon driver.")

# Processors
hardware_help = _("Specify the amount of memory and number of processors to allocate for the VM.")
processors_note = _("For best performance, the number of virtual processors should be less than or equal to the number of physical processors.")

# Graphics
graphics_note_para = _("Paravirtualized graphics require that an appropriate driver is installed in the operating system.")
graphics_note_none = _("The VM will operate like a server without a monitor.  You may still access the operating system via the virtualized serial port, or through any operating system supported services such as ssh or VNC.")
graphics_hw_help = _("Please specify the type of virtualized graphics hardware.")
graphics_hw_para = _("Paravirtualized Graphics Adapter")
graphics_hw_vesa = _("VESA VGA")
graphics_hw_cirrus = _("Cirrus Logic GD5446 VGA")
graphics_hw_none = _("No Graphics Support")
graphics_adapter = _("Graphics Adapter")
graphics_screen_resolution = _("Screen Resolution")

keyboard_hw_help = _("Please specify the keyboard translation map file.")

# Sound
sound_hw_help = _("Please specify the sound device.")
sound_hw_ac97 = _("Intel 82801AA Audio Codec 97")
sound_hw_es1370 = _("Ensoniq AudioPCI ES1370")
sound_hw_ich6 = _("Intel I/O Controller Hub 6 (ICH6)")
sound_hw_sb16 = _("Creative Sound Blaster 16")
sound_hw_none = _("No Sound Support")
sound_hw_all = _("All")
sound_card = _("Sound Card")

# Host Devices
host_devices = _("Host Devices")
host_device_help = _("Specify a host device for the VM.  This will give the VM direct access to the device.")
host_devices_note = _("Host devices cannot be shared between VMs or between a VM and the host.")
manage_vm_devices = _("Manage VM Devices")
defined_vm_devices = _("Defined VM Devices")
pci_host_devices = _("PCI Host Devices")
usb_host_devices = _("USB Host Devices")
host_devices_warn_note = _("Do not add a PCI or USB device to this VM that is needed by the host to function properly.")

# Disks
virtual_disk = _("Virtual Disk")
virtual_disks = _("Virtual Disks")
PXE_boot = _("PXE Boot")
size_gb = _("Size (GB)")
create_sparse = _("Create Sparse Image File")
read_only = _("Read-Only Access")
type_hard_disk = _("Hard Disk")
type_cdrom = _("CD-ROM or DVD")
type_floppy = _("Floppy Disk")
type_pxe = _("PXE")
type_rear = _("Relax and Recover")
cache_mode = _("Cache Mode")

# PXE Install
pxe_no_pxe_server = _("Can't reach the pxe server. Possible reasons are an improperly configured network or firewall restrictions.")
pxe_no_config = _("Can't get the pxelinux.cfg/default file from the pxe server.")
pxe_no_kernel = _("Can't download the kernel and initrd from the server.")
pxe_kernel_warn = _("This kernel image may not be a paravirtualized xen kernel required for installation, Continue?")
pxe_no_bridge = _("Unable to identify a configured network bridge.")
pxe_no_tftp = _("Paravirtualized PXE booting requires the use of tftp or atftp.  Please install one of these packages.")

# Network
nic_e100 = _("Fully Virtualized Intel e100")
nic_e1000 = _("Fully Virtualized Intel e1000")
nic_eepro100 = _("Fully Virtualized Intel eepro100")
nic_pcnet = _("Fully Virtualized AMD PCnet 32")
nic_ne2k_isa = _("Fully Virtualized NE2000 (ISA Bus)")
nic_ne2k_pci = _("Fully Virtualized NE2000 (PCI Bus)")
nic_rtl8139 = _("Fully Virtualized Realtek 8139")
mac_address = _("MAC Address")
random_mac = _("Randomly generated MAC address")
specified_mac = _("Specified MAC address")

# Prompts for individual fields
extra_args_prompt = _("Additional Arguments")
network_url = _("Network URL")
memory = _("Memory")
processors = _("Processors")
os_settings_prompt = _("Automated install file or URL")
available_memory_prompt = _("Available Memory")
available_cpus_prompt = _("Available Processors")
memory_prompt = _("Initial Memory")
max_memory_prompt = _("Maximum Memory")
vcpus_prompt = _("Virtual Processors")
installation_source_prompt = _("Installation Source")
automated_installation_prompt = _("Automated Installation")
operating_system_prompt = _("Operating System")
on_poweroff = _("Power Off")
on_reboot = _("Reboot")
on_crash = _("Crash")
# Strings defined above with alternate names
name_prompt = name
description_prompt = description
graphics_adapter_prompt = graphics_adapter
keymap_prompt = keymap
sound_card_prompt = sound_card
host_devices_prompt = host_devices

#  Descriptive names of automated install methods
kickstart_desc = _("Kickstart file or URL")
autoyast_desc = _("AutoYaST file")
nwresponse_desc = _("NetWare response file")

#  Titles on dialog boxes
progress_title = _("Creating the Virtual Machine")
config_title = _("Writing the configuration file")
locate_os_settings = _("Locate Operating System Settings File")
locate_disk = _("Locate Disk or Disk Image")

#  CLI
another_disk = _("Do you want to add another virtual disk?")
another_nic = _("Do you want to add another virtual network adapter?")
add_disk_type = _("What type of virtual disk do you want to add?")
add_disk_source = _("Where will the virtual disk physically reside?")
add_nic_type = _("What type of virtual network adapter do you want to add?")
create_sparse_file = _("Create a sparse image file for the virtual disk?")

default = _("Default")

# Upgrade
os_upgrade_type = _("Operating System Type")
virtual_machines = _("Managed Virtual Machines")
config_file = _("Configuration File")
upgrade_network_url_help = _("Specify the URL containing the network installation source.")

# Hypervisor Errors
hypervisor_none = _("A hypervisor is not running.  For kvm, load the kvm kernel modules.  If you want to run xen, reboot and load the xen kernel.")


prompt = lambda text: text + ':'
bold_prompt = lambda text: '<b>%s:</b>' % text
small = lambda text: '<small>%s</small>' % text

def set_text(name, widget, text=None, modifier=None, markup=False):
    if not text:
        text = eval(name)
    if modifier:
        text = modifier(text)
    if markup:
        widget.set_markup(text)
    else:
        widget.set_text(text)
